from  consts import *
import  sys
class AuthorsAnalyzer(object):
    def __init__(self):
        self._authors_features = gl.load_sframe("/data/sframes/authors_features.sframe")

    def get_authors_papers_by_year(self):
        papers_sf = gl.load_sframe(PAPERS_SFRAME)['Paper ID', 'Paper publish year']
        self._authors_features = self._authors_features.join(papers_sf, how="left")

    def get_authors_papers_sframe(self, start_year, end_year):
        papers_sf = gl.load_sframe(PAPERS_ALL_FEATURES)
        if start_year is None:
            start_year = papers_sf['Paper publish year'].min()
        if end_year is None:
            end_year = 2016

        logger.info("Createing merged sframe between years %s & %s " % (start_year, end_year))
        authors_year_sf = gl.SFrame()
        for i in range(start_year, end_year + 1):
            print "Adding authors activity year %s" % i
            logger.info("Adding authors activeity year %s" % i)
            sf = papers_sf[papers_sf['Paper publish year'] == i]
            sf = sf.join(self._authors_features)
            authors_year_sf = authors_year_sf.append(sf)
        return authors_year_sf

    def create_sgraphs(self):
        aff_sf = gl.load_sframe(PAPER_AUTHOR_AFFILIATIONS_SFRAME)
        papers_sf = gl.load_sframe(PAPERS_ALL_FEATURES)

        g = gl.SGraph(vertices=papers_sf,edges=aff_sf,vid_field="Paper ID", src_field="Paper ID", dst_field="Author ID")


if __name__ == "__main__":
    a = AuthorsAnalyzer()
    start_year = int(sys.argv[1])
    end_year = int(sys.argv[2])

    sf = a.get_authors_papers_sframe(start_year, end_year)
    sf.save("/data/sframe/authors_papers_%s_%s.sframe" % (start_year,end_year))



