import graphlab as gl
import graphlab.aggregate as agg

def get_column_count_sframe(sf, col_name, sort_by_count=True):
    g =  sf.groupby(col_name, {'Count': agg.COUNT()})
    if sort_by_count:
        g = g.sort("Count")
    return g

def filter_sframe_by_func(sf, filter_func):
    """
    Filter Sframe using a filter function
    :param sf: SFrame object
    :param filter_func: a function that return 1 for the lines we want to keep and 0 for the lines we want to filter out
    :return: filtered SFrame
    :rtype: gl.SFrame
    """
    if filter_func is None:
        return sf

    return sf[sf.apply(lambda r: filter_func(r))]

def decode_utf8_to_ascii(s):
    # loss special chars
    udata=s.decode("utf-8")
    return udata.encode("ascii","ignore")